/**************************************************************************/
/*                                                                        */
/*  Thibaut Balabonski, Sylvain Conchon, Jean-Christophe Filliâtre,       */
/*  Kim Nguyen, Laurent Sartre                                            */
/*                                                                        */
/*  Informatique - MP2I/MPI - CPGE 1re et 2e années.                      */
/*  Cours et exercices corrigés. Éditions Ellipses, 2022.                 */
/*                                                                        */
/*  https://www.informatique-mpi.fr/                                      */
/*                                                                        */
/**************************************************************************/

#include "prelude.h"
#include "arith.h"

int incr(int c[], int n) {
  int i = 0;
  while (i < n && c[i]) {
    c[i] = 0;
    i++;
  }
  if (i < n) c[i] = 1;
  return i;
}

int first_one(int c[], int n) {
  for (int i = 0; i < n; i++) {
    if (c[i] == 1) { return i; }
  }
  return -1;
}

void print_counter(int c[], int n) {
  for (int i = n-1; i >= 0; i--) {
    printf("%d", c[i]);
  }
  printf("\n");
}

void print_histo(int h[], int n) {
  for (int i = 0; i < n; i++) {
    printf("%d:\t%d\n", i+1, h[i]);
  }
}

int main(int argc, char **argv) {
  int n = atoi(argv[1]);
  int *counter = calloc(n, sizeof(int));
  int *histo = calloc(n, sizeof(int));
  int t = arith_power(2, n);
  for (int i = 0; i < t; i++) {
    int j = incr(counter, n);
    histo[j]++;
  }
  print_counter(counter, n);
  print_histo(histo, n);
  return 0;
}
